;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Type             :   Tut                                                         ;;
;; Project          :   Basic mouse driver                                          ;;
;; Ver              :   00.01                                                       ;;
;; Author           :   Dex (Team DexOS)                                            ;;
;; Website          :   www.dex4u.com                                               ;;
;; Date             :   March 11, 2007                                              ;;
;; Filename         :   Mouse.asm                                                   ;;
;; Assembler Command:   FASM mouse.asm mouse.com                                    ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; NOTES:         This is a basic mouse demo, but it will NOT work in a dosbox      ;;
;;                under windows, most be in real dos or clone or in real mode       ;;
;;                without a OS.                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Disclaimer       :                                                               ;;
;; This software is provided "AS IS" without warranty of any kind, either           ;;
;; expressed or implied, including, but not limited to, the implied                 ;;
;; warranties of merchantability and fitness for a particular purpose. The          ;;
;; entire risk as to the quality and performance of this software is with           ;;
;; you.                                                                             ;;
;; In no event will the author's, distributor or any other party be liable to       ;;
;; you for damages, including any general, special, incidental or                   ;;
;; consequential damages arising out of the use, misuse or inability to use         ;;
;; this software (including but not limited to loss of data or losses               ;;
;; sustained by you or third parties or a failure of this software to operate       ;;
;; with any other software), even if such party has been advised of the             ;;
;; possibility of such damages.                                                     ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

use16
org 0x100
;====================================================;
; Start.                                             ;
;====================================================;
start:
	mov   ax,cs
	mov   ds,ax
	mov   es,ax
	call  Cls
	call  Welcome
	cli
;====================================================;
; Set mouse up.                                      ;
;====================================================;
	call  PS2MouseSetUp
	push  ds
	xor   ax,ax
	mov   ds,ax
;====================================================;
; Hook into isr.                                     ;
;====================================================;
	mov   bx,WORD[ds:09h*4+0]
	mov   cx,WORD[ds:09h*4+2]
	mov   word[cs:OldInt9],bx
	mov   word[cs:OldInt9+2],cx
	mov   WORD[ds:09h*4+0], key_isr
	mov   WORD[ds:09h*4+2],cs
	mov   WORD[ds:74h*4+0],Mouse_isr
	mov   WORD[ds:74h*4+2],cs
	pop   ds
	call  SetMouseOn
	sti
	int   74h
;====================================================;
; Main loop.                                         ;
;====================================================;
NoEsc:
	mov   [keybuffer],0
	hlt
	cmp   [keybuffer],1
	jne   NoEsc
;====================================================;
; Set isr to normal.                                 ;
;====================================================;
	call  SetMouseOff
	cli
	mov   bx,word[cs:OldInt9]
	mov   cx,word[cs:OldInt9+2]
	push  ds
	xor   ax,ax
	mov   ds,ax
	mov   WORD[ds:09h*4+0],bx
	mov   WORD[ds:09h*4+2],cx
	pop   ds
	sti
;====================================================;
; Return to CLI.                                     ;
;====================================================;
	 int   20h

;====================================================;
; Temp key isr                                       ;
;====================================================;
key_isr:
	pusha
	xor   eax,eax
	in    al,0x60
	mov   [keybuffer],al
	mov   al,0x20
	out   0xa0,al
	out   0x20,al
	popa
	iret

;====================================================;
;  Clear screen.                                     ;
;====================================================;
Cls:
	mov   ax,0x0600
	mov   bh,0x07
	mov   cx,0x0000
	mov   dx,0x184f
	int   10h
	ret
;====================================================;
;  Set cursor.                                       ;
;====================================================;
Cursor:
	mov   ah,02
	mov   bh,00
	mov   dx,0x0100
	int   10h
	ret
;====================================================;
;  Welcome.                                          ;
;====================================================;
Welcome:
	mov   si,Message
	call  print
	ret

;====================================================;
;  print.                                            ;
;====================================================; 
print:
	mov   ah,0Eh
again1:
	lodsb
	or   al,al
	jz   done1
	int  10h
	jmp  again1
done1:
	ret  

;====================================================;
; Data.                                              ;
;====================================================;
OldInt9    dw 0,0
keybuffer  db 0
Message    db  '  Basic Mouse Driver, by Dex, move and press button to test, Esc to exit.',0
include 'Mouse.inc'

